# - Setup Cooldowns
execute as @a[tag=!warp_totems.setup_cooldowns] at @s run scoreboard players set @s warp_totems.item_use_cooldown 0
execute as @a[tag=!warp_totems.setup_cooldowns] at @s run scoreboard players set @s warp_totems.warp_totem_teleport_cooldown 0
execute as @a[tag=!warp_totems.setup_cooldowns] at @s run tag @s add warp_totems.setup_cooldowns


# - Decrease Item Use Cooldown
execute as @a[scores={warp_totems.item_use_cooldown=1..}] at @s run scoreboard players remove @s warp_totems.item_use_cooldown 1
execute as @a[scores={warp_totems.warp_totem_teleport_cooldown=1..}] at @s run scoreboard players remove @s warp_totems.warp_totem_teleport_cooldown 1

# - Teleport Countdown
execute as @a[scores={warp_totems.warp_totem_teleport_duration=100}] at @s run tellraw @s {"text": "Teleporting in 5", "color":"light_purple"}
execute as @a[scores={warp_totems.warp_totem_teleport_duration=100}] at @s run playsound ui.button.click master @s ~ ~ ~
execute as @a[scores={warp_totems.warp_totem_teleport_duration=80}] at @s run tellraw @s {"text": "Teleporting in 4", "color":"light_purple"}
execute as @a[scores={warp_totems.warp_totem_teleport_duration=80}] at @s run playsound ui.button.click master @s ~ ~ ~
execute as @a[scores={warp_totems.warp_totem_teleport_duration=60}] at @s run tellraw @s {"text": "Teleporting in 3", "color":"light_purple"}
execute as @a[scores={warp_totems.warp_totem_teleport_duration=60}] at @s run playsound ui.button.click master @s ~ ~ ~
execute as @a[scores={warp_totems.warp_totem_teleport_duration=40}] at @s run tellraw @s {"text": "Teleporting in 2", "color":"light_purple"}
execute as @a[scores={warp_totems.warp_totem_teleport_duration=40}] at @s run playsound ui.button.click master @s ~ ~ ~
execute as @a[scores={warp_totems.warp_totem_teleport_duration=20}] at @s run tellraw @s {"text": "Teleporting in 1", "color":"light_purple"}
execute as @a[scores={warp_totems.warp_totem_teleport_duration=20}] at @s run playsound ui.button.click master @s ~ ~ ~


# - Walking
execute as @a[scores={warp_totems.walking=1..}] at @s run scoreboard players add @s warp_totems.moving 1
execute as @a[scores={warp_totems.walking=1..}] at @s run scoreboard players reset @s warp_totems.walking

# - Sprinting
execute as @a[scores={warp_totems.sprinting=1..}] at @s run scoreboard players add @s warp_totems.moving 1
execute as @a[scores={warp_totems.sprinting=1..}] at @s run scoreboard players reset @s warp_totems.sprinting

# - Crouching
execute as @a[scores={warp_totems.crouching=1..}] at @s run scoreboard players add @s warp_totems.moving 1
execute as @a[scores={warp_totems.crouching=1..}] at @s run scoreboard players reset @s warp_totems.crouching


# - Teleport
execute as @a[scores={warp_totems.warp_totem_teleport_duration=1}] at @s run function warp_totems:warp_totem/macro/teleport with storage warp_totems:warp_totem Macro
execute as @a[scores={warp_totems.warp_totem_teleport_duration=1}] at @s run scoreboard players reset @s warp_totems.warp_totem_teleport_duration

# - Canceled Moved
execute as @a[scores={warp_totems.warp_totem_teleport_duration=1.., warp_totems.moving=1..}] at @s run tellraw @s {"text":"Teleportation failed: moved", "color":"red"}
execute as @a[scores={warp_totems.warp_totem_teleport_duration=1.., warp_totems.moving=1..}] at @s run playsound block.anvil.land master @s ~ ~ ~
execute as @a[scores={warp_totems.warp_totem_teleport_duration=1.., warp_totems.moving=1..}] at @s run scoreboard players set @s warp_totems.warp_totem_teleport_cooldown 20
execute as @a[scores={warp_totems.warp_totem_teleport_duration=1.., warp_totems.moving=1..}] at @s run scoreboard players set @s warp_totems.warp_totem_teleport_duration 0

# - Canceled Damage Taken
execute as @a[scores={warp_totems.warp_totem_teleport_duration=1.., warp_totems.damage_taken=1..}] at @s run tellraw @s {"text":"Teleportation failed: damage taken", "color":"red"}
execute as @a[scores={warp_totems.warp_totem_teleport_duration=1.., warp_totems.damage_taken=1..}] at @s run playsound block.anvil.land master @s ~ ~ ~
execute as @a[scores={warp_totems.warp_totem_teleport_duration=1.., warp_totems.damage_taken=1..}] at @s run scoreboard players set @s warp_totems.warp_totem_teleport_cooldown 20
execute as @a[scores={warp_totems.warp_totem_teleport_duration=1.., warp_totems.damage_taken=1..}] at @s run scoreboard players set @s warp_totems.warp_totem_teleport_duration 0

# - Decrease Teleport Duration
execute as @a[scores={warp_totems.warp_totem_teleport_duration=1..}] at @s run scoreboard players remove @s warp_totems.warp_totem_teleport_duration 1


# - Moving
execute as @a[scores={warp_totems.moving=1..}] at @s run scoreboard players reset @s warp_totems.moving

# - Damage Taken
execute as @a[scores={warp_totems.damage_taken=1..}] at @s run scoreboard players reset @s warp_totems.damage_taken
